Attribute VB_Name = "handleChatEvents"
Option Compare Binary
Option Explicit

Public Sub Unload_BNLSwinsock(Index As Integer)
On Error GoTo Err
    Unload frmMain.Bnls_wS(Index)
Err:
End Sub
'get'er done


Public Sub Parse0x0F(ByRef Index As Integer)
Dim lEID As Long, lFlags As Long, sMessage As String, sUsername As String, lPing As Long

    With PBuffer
        lEID = .GetDWORD
        lFlags = .GetDWORD
        lPing = .GetDWORD
        .GetDWORD 'ip
        .GetDWORD 'acc#
        .GetDWORD 'regAuthority
        sUsername = .GetNTstring
        sMessage = .GetNTstring
    End With


    If InStrB(sMessage, "\rtf") Then sMessage = Replace$(sMessage, "\rtf", ".rtf")
    'protect against malicous input
    Select Case lEID
        Case &H1
            handleCEJoin sUsername, sMessage, lPing, lFlags, -1, 0, Index
        'USERS: recieved after joining a channel, after CHAN:
        Case &H13
            handleCEError sMessage, Index
        'ERROR: can be invalid channel, muted reply, not logged on, ect
        Case &H2
            handleCEJoin sUsername, sMessage, lPing, lFlags, -1, 1, Index
        'JOIN: a user joins channel you are in
        Case &H3
            handleCELeave sUsername, lPing, False, Index
        'LEAVE: a user leaves the channel you are in
        Case &H12
            handleCEInfo sUsername, sMessage, Index
        'INFO: recieved when a user is kicked/banned, can be an MOTD, /who, ect
        Case &H7
            handleCEChan sMessage, lPing, Index
        'CHAN: recieved when you join a new channel, before anything else
        Case &H9
            handleCEFlags sUsername, sMessage, lPing, lFlags, Index 'will remove, store slot, and re-add
        'FLAGS: recieved during a user flag update, such as operator, ignore, ect
        Case &H4
            If Not aProfile(Index).ChatIconChanged And botElements.ActiveChatIndex <> Index Then handleNewChatIconChange True, Index
            'change the icon to display new text
            handleCEWhispFrom sUsername, sMessage, lPing, Index
        'WHISPFROM: you recieved a whisper
        Case &HA
            handleCEWhispTo sUsername, sMessage, lPing, Index
        'WHISPTO: you sent out a whisper
        Case &H17
            handleCEEmote sUsername, sMessage, lPing, Index
        'EMOTE: you recieved a /me
        Case &H5
            handleCETalk sUsername, sMessage, lPing, Index
        'TALK: you recieved chatter
        Case &HF
            handleCERestricted sMessage, Index
        'RESTRICTED: recieved when doing /who on a /clan private channel, or when attempting to non-create join a restricted channel using &HC
    End Select


    If Err.Number <> 0 Then handleProjectError Index, "Error:sub|Parse0x0F -> [" & Err.Number & "] " & Err.Description

End Sub

Private Sub handleCERestricted(ByRef theMessage As String, ByRef Index As Integer)
    AddChat 0, Index, vbRed, theMessage & GetString(6) 'has Clan Private enabled.
End Sub
'called usually when a channel is on CP

Public Function decrypt_Message(ByVal theMessage As String) As String
Dim arrIndex As Integer, theKey As Integer
Dim charAsc As Integer

    theKey = (Asc(Mid$(theMessage, 3, 1)) - 122)
    'sets thekey
    For arrIndex = 4 To Len(theMessage)
        charAsc = (Asc(Mid$(theMessage, arrIndex, 1)) - theKey)
        'sets original char asc
        decrypt_Message = decrypt_Message & Chr$(charAsc)
    Next arrIndex
    
End Function
'decrypts an encrypted message
'custom keys are not supported at the moment

Private Sub handleCETalk(ByVal theName As String, ByRef theMessage As String, ByRef thePing As Long, ByRef Index As Integer)
Dim FilteredData As Boolean


    If Left$(theMessage, 2) = "" Then theMessage = "[Decrypted] " & decrypt_Message(theMessage)
    'if encrypted sign
    FilteredData = FilteredItem(theName, theMessage, 2, Index)
    If InStrB(aProfile(Index).OperatorList, ACross & theName & ASnake) = 0 Then
        If Not FilteredData Then AddChat 0, Index, vbYellow, theName, &H8080&, ":" & thePing & ASpace, vbWhite, theMessage
        'add chat
        'not a flood
    'not an operator
    Else
        If InStrB(theName, "#Blizzard") Then
            If Not FilteredData Then AddChat 0, Index, vbCyan, theName, &H808000, ":" & thePing & ASpace, vbCyan, theMessage
            'if rep
        Else
            If Not FilteredData Then AddChat 0, Index, vbWhite, theName, &HC0C0C0, ":" & thePing & ASpace, vbWhite, theMessage
            'if operator
        End If
    'is operator/rep
    End If
    'add text
    
    If Not FilteredData Then
        If Not aProfile(Index).ChatIconChanged And botElements.ActiveChatIndex <> Index Then
            If aProfile(Index).Channel <> aProfile(botElements.ActiveChatIndex).Channel Then handleNewChatIconChange True, Index
            'only update icon if the profile is not of one already viewing the channel
        End If
        'change the icon to display new text
        HandleMemoMail theName, theMessage, Index
        'check if theyre issuing a memo or mail
        Set_IdleTick theName, Index, False, GTC
        'sets the users new idleTalk tick and unGrays if grayed
        If Not Remote_Commands(theName, theMessage, thePing, Index, False, False, False) Then If LCase$(theMessage) <> "!mail" Then CheckMail theName, Index
        'issue command check, can also return true/false for command issued
        'check if this user has mail if flood filters arent enabled and if a remote cmd wasnt issued
    End If
  
End Sub
'called when 'talk' is recieved


Private Sub handleCEEmote(ByRef theName As String, ByRef theMessage As String, ByRef thePing As Long, ByRef Index As Integer)
Dim isMyself As Boolean
Dim FilteredData As Boolean

    If Left$(theMessage, 2) = "" Then theMessage = "[Decrypted] " & decrypt_Message(theMessage)
    'if encrypted sign

    If theName = aProfile(Index).RealName Then isMyself = True
    'if true then emotes are of my own, 'my' being the bot user
    If isMyself Then
        aProfile(botElements.QueueNext).ChatSelfTimestamp = True
        'enables next chat entry to have the self timestamp
    Else
        FilteredData = FilteredItem(theName, theMessage, 2, Index)
    End If
    
    If InStrB(aProfile(Index).OperatorList, ACross & theName & ASnake) = 0 Then
        'if not the bot user talking check against filters
        If Not FilteredData Then AddChat 0, Index, &H8080&, "<", &HC0FFFF, theName, &H8080&, ":" & thePing, &HC0FFFF, ASpace & theMessage, &H8080&, ">"
      'not a flood
    'not operator
    Else
        If InStrB(theName, "#Blizzard") Then
            If Not FilteredData Then AddChat 0, Index, &H808000, "<", vbCyan, theName, &H808000, ":" & thePing, vbCyan, ASpace & theMessage, &H808000, ">"
            'if rep
        Else
            If Not FilteredData Then AddChat 0, Index, &HC0C0C0, "<", vbWhite, theName, &HC0C0C0, ":" & thePing, vbWhite, ASpace & theMessage, &HC0C0C0, ">"
            'if normal operator
        End If
    'is operator/rep
    End If
        
    If Not FilteredData Then
        If Not aProfile(Index).ChatIconChanged And botElements.ActiveChatIndex <> Index Then
            If aProfile(Index).Channel <> aProfile(botElements.ActiveChatIndex).Channel Then handleNewChatIconChange True, Index
            'only update icon if the profile is not of one already viewing the channel
        End If
        'change the icon to display new text
        Remote_Commands theName, theMessage, thePing, Index, False, False, False
        'issue command check, can also return true/false for command issued
    End If
    
  
End Sub
'called when an emote is recieved


Private Sub handleCEError(ByRef theMessage As String, ByRef Index As Integer)

    If aProfile(Index).Channel = "The Void" Then '
        If aProfile(Index).SpamGuardErrorMessage = theMessage Then Exit Sub
        'old error
        aProfile(Index).SpamGuardErrorMessage = theMessage
        'prevent spam
    End If
    'don't display duplicate error messages if voided

    If Not aProfile(Index).ChatIconChanged And botElements.ActiveChatIndex <> Index Then handleNewChatIconChange True, Index
    'change the icon to display new text

    AddChat 0, Index, vbRed, theMessage
    
    
End Sub
'called when an error chatevent is called


Private Sub handleCEWhispFrom(ByRef theName As String, ByRef theMessage As String, ByRef thePing As Long, ByRef Index As Integer)

    Modify_RecentWhisper theName
    'store recent whispers
    
    If Left$(theMessage, 2) = "" Then theMessage = "[Decrypted] " & decrypt_Message(theMessage)
    'if encrypted sign

    If Not FilteredItem(theName, theMessage, 2, Index, , -2) Then
        aProfile(Index).LastWhisperName = theName
        'used for the /  r command
        AddChat 0, Index, vbYellow, "From" & AFakeSpace & theName, &H8080&, ":" & thePing & ASpace, &HC0C0C0, theMessage
        'add to the main rtb
        If botElements.WhisperWindow <> 0 Then
            If Index = botElements.ActiveChatIndex Then
                AddChat 1, 0, vbYellow, "From" & AFakeSpace & AttachRealmSingle(theName, Index), &H8080&, ":" & thePing & ASpace, &HC0C0C0, theMessage
            'if whisper in is for our current profile then
            Else
            'if inbound is from a profile other than one being viewed
                AddChat 1, 0, vbYellow, "From" & ASpace & theName, &H8080&, ":" & thePing & ASpace, &H5A8B, "(" & AttachRealmSingle(aProfile(Index).RealName, Index) & ") ", &HC0C0C0, theMessage
            End If
        'if whisper window is visible
        End If
        'add chat
        Set_IdleTick theName, Index, False, GTC
        'resets idle tick
        HandleMemoMail theName, theMessage, Index
        'check if theyre issuing a memo or mail
        Remote_Commands theName, theMessage, thePing, Index, False, True, False
        'issue command check, can also return true/false for command issued
    End If
    
End Sub
'called when you recieve a whisper

Private Sub Modify_RecentWhisper(ByRef theName As String)
Dim arrIndex As Byte
Static entryLoc As Byte

    For arrIndex = 0 To 2
        If botElements.RecentWhispers(arrIndex) = theName Then Exit Sub
    Next arrIndex
    'if already in list cancel
    botElements.RecentWhispers(entryLoc) = theName
    entryLoc = entryLoc + 1
    'raise
    If entryLoc = 3 Then entryLoc = 0
    'reset
    'sets
    
End Sub
'sets up the recent whisper user array

Private Sub handleCEWhispTo(ByRef theName As String, ByRef theMessage As String, ByRef thePing As Long, ByRef Index As Integer)

    If Left$(theMessage, 2) = "" Then theMessage = "[Decrypted] " & decrypt_Message(theMessage)
    'if encrypted sign

    AddChat 0, Index, vbYellow, "To" & AFakeSpace & theName, &H8080&, ":" & thePing & ASpace, &HC0C0C0, theMessage
    If botElements.WhisperWindow <> 0 And Index = botElements.ActiveChatIndex Then AddChat 1, Index, vbYellow, "To" & AFakeSpace & theName, &H8080&, ":" & thePing & ASpace, &HC0C0C0, theMessage
    'only add to whisper window if is viewing profile

End Sub
'called when you send out a whisper

Private Sub handleCEInfo(ByRef theName As String, ByRef theMessage As String, ByRef Index As Integer)
Static WhoCount As Integer, WhoTick As Currency, OpCount As Integer, WhoChannel As String
Dim theTick As Currency
Dim infoColor As Long

    infoColor = RGB(192, 140, 0)
    'default

    theTick = GTC
    If WhoTick <> 0 Then
        If theTick - WhoTick > 1000 Then
            WhoTick = 0
            WhoCount = 0
            OpCount = 0
        End If
    End If
    'if enough time has passed since last who check then reset variables
  
    If InStrB(theMessage, "Users in channel") Then
        WhoTick = theTick
        'sets tick
        WhoChannel = Mid$(theMessage, 18)
        'sets channel
        WhoCount = 0
        OpCount = 0
        'reset
        infoColor = &HFF9933
        'a diff color for channel name
    Else
        If WhoTick <> 0 Then
        'if not 0 then that means a who was recently received
            If InStrB(theMessage, ", ") Then
            'if has a comma or doesnt have a space then it should be a who msg
                Dim whoSplit() As String, whoColor1 As Long, whoColor2 As Long, parsedName1 As String, parsedName2 As String
                whoSplit = Split(theMessage, ", ")
                'splits to get both names or just one
                WhoCount = WhoCount + 2
                '+2 count
                parsedName1 = whoSplit(0)
                'by default
                If Left$(whoSplit(0), 1) = "[" And Right$(whoSplit(0), 1) = "]" And whoSplit(0) = UCase$(whoSplit(0)) Then
                    whoColor1 = &H40C0
                    OpCount = OpCount + 1
                    'if is an op
                    parsedName1 = Mid$(parsedName1, 2, Len(parsedName1) - 2)
                    'is op so reparse
                'if a mod
                Else
                    whoColor1 = infoColor
                    'if not
                End If
                'since the message will always contain at least 1 user we dont need to check the ubound like above
                If UBound(whoSplit) = 1 Then
                    'additional user
                    parsedName2 = whoSplit(1)
                    'by default
                    If Left$(whoSplit(1), 1) = "[" And Right$(whoSplit(1), 1) = "]" And whoSplit(1) = UCase$(whoSplit(1)) Then
                        whoColor2 = &H40C0
                        OpCount = OpCount + 1
                        '
                        parsedName2 = Mid$(parsedName2, 2, Len(parsedName2) - 2)
                        '
                    'if is an op
                    Else
                        whoColor2 = infoColor
                        '
                    'if not default color
                    End If
                    'determine if op
                End If
                'now parse the second name
                AddChat 0, Index, whoColor1, whoSplit(0), vbYellow, ", ", whoColor2, whoSplit(1)
                'add the chat
                Set_ComboPrev WhoChannel & ASpace & GetString(60) & (WhoCount) & ", " & GetString(61) & OpCount, True
                'upd ate the display combo box
            'if instr ', '
            ElseIf InStrB(theMessage, ASpace) = 0 Then
            'no comma and no space, is a single name
                parsedName1 = theMessage
                'default
                WhoCount = WhoCount + 1
                If Left$(theMessage, 1) = "[" And Right$(theMessage, 1) = "]" And theMessage = UCase$(theMessage) Then
                    whoColor1 = &H40C0
                    OpCount = OpCount + 1
                    'if is an op
                    parsedName1 = Mid$(parsedName1, 2, Len(parsedName1) - 2)
                    'is op so reparse
                Else
                    whoColor1 = infoColor
                End If
                'if is op
                AddChat 0, Index, whoColor1, theMessage
                'add the chat
                Set_ComboPrev WhoChannel & ASpace & GetString(60) & (WhoCount) & ", " & GetString(61) & OpCount, True
                'upd ate the display combo box
            End If
            '
            If aProfile(Index).Operator And aProfile(Index).Sweepban <> 0 Then
                parsedName1 = RemoveFirstStar(AttachRealmSingle(parsedName1, Index))
                parsedName2 = RemoveFirstStar(AttachRealmSingle(parsedName2, Index))
                'adds realm and removes stars while banning
                If LenB(parsedName1) Then
                    parsedName1 = AttachRealmSingle(parsedName1, Index)
                    If aProfile(Index).Sweepban = 2 Then QueueString ASquelch & parsedName1 & Auto001, Index
                    QueueString ABan & parsedName1 & Auto001, Index
                End If
                'if name1 isnt null
                If LenB(parsedName2) Then
                    parsedName2 = AttachRealmSingle(parsedName2, Index)
                    If aProfile(Index).Sweepban = 2 Then QueueString ASquelch & parsedName2 & Auto001, Index
                    QueueString ABan & parsedName2 & Auto001, Index
                End If
                'if name2 isnt null
            End If
            'if mod and this is a swee p ban
            Exit Sub
        'if who tick isnt null
        End If
    'if not instrb message   user s in chann el
    End If
            

    If Not FilteredItem(vbNullString, theMessage, 3, Index) Then
        If aProfile(Index).FilterTriggered And InStrB(theMessage, " has been squ") Then
        'if is a squelch message and filters are enabled
            Dim nameIgnored As String
            nameIgnored = Left$(theMessage, InStr(theMessage, ASpace) - 1)
            'set the name as pulled from the info msg
            If Left$(aProfile(Index).FilterNameIgnored, Len(nameIgnored)) <> LCase$(nameIgnored) Then Exit Sub
            'user being ignored doesnt match who we expect it to be after a manual ignore, so dont show.
            'only perform this when filters are enabled.
            'the filter name ignored variable is already lowercase
        End If
        'if iggy was recently sent
        If Not aProfile(Index).ChatIconChanged And botElements.ActiveChatIndex <> Index Then
            If aProfile(Index).Channel <> aProfile(botElements.ActiveChatIndex).Channel Then
                If InStrB(theMessage, "was kicked") Or InStrB(theMessage, "was banned") Then handleNewChatIconChange True, Index
            End If
            'only update icon if the profile is not of one already viewing the channel
            'and if was a kick or ban
        End If
        'change the icon to display new text
        AddChat 0, Index, infoColor, theMessage
    End If
    'add chat if not filtered'
  
End Sub
'called when an info chatevent is called


Public Sub Set_ComboPrev(ByRef sText As String, ByRef ignoreTick As Boolean)
Static comboPreviousTick As Currency

    If GTC - comboPreviousTick < 6000 And Not ignoreTick Then Exit Sub
    'exit sub if changing the combo index too soon within last attempt
    frmMain.comboPreviousSent.Text = sText
    'sets
    comboPreviousTick = GTC
    'last set tick
    If Not aProfile(botElements.ActiveChatIndex).FilterTriggered Then
        frmMain.comboPreviousSent.ForeColor = &H0
    'filters arent enabled, normal back color
    Else
        frmMain.comboPreviousSent.ForeColor = &HC0&      ' &H8000&
    'filters enabled set a diff back color
    End If
    
  
End Sub
'sets text and stores last set, so we dont change too soon with other items

Private Sub handleCEFlags(ByRef theName As String, ByRef theMessage As String, ByRef thePing As Long, ByRef theFlags As Long, ByRef Index As Integer)
Dim nameIndex As Integer
    
    handleCEJoin theName, theMessage, thePing, theFlags, nameIndex, 2, Index
    're-adds to proper place
    If (theFlags And 32) = 32 Then
    'flag update to squelch. see if they have access and if so unignore
    'check access and if not 0 unignore
        If get_Access(theName, Index) <> 0 Then AutoUnignore theName, Index
        'user has access, unignore them
    End If

End Sub
'handled upon a flag update

Private Sub AutoUnignore(ByRef theName As String, ByRef Index As Integer)

    Dim thisTick As Currency
    thisTick = GTC
    If thisTick - aProfile(Index).UnIgnoreTick > 200 Then
        'limit how many unignores are done. this is incase you have multiple users ignored under
        'the same ip. theres no need to unignore them all.
        aProfile(Index).UnIgnoreTick = thisTick
        'set tick
        QueueString AnUnignore & ASpace & theName, Index, , True
        'queue
    End If
                
End Sub

Private Sub handleCEChan(ByRef theChannel As String, ByRef thePing, ByRef Index As Integer)
    
    If LCase$(theChannel) = LCase$(aProfile(Index).ChannelHome) Or theChannel = "The Void" Then
    'if same as last channel or void
        '4
        If frmMain.lstUserStorage(Index).ListCount <> 0 Then
        'if have a list to read
            aProfile(Index).ChannelUsers = vbNullString
            'reset
            Dim arrIndex As Integer, IndexLoc As Integer, userSplit() As String
            Dim idleTick As Currency, StringLoc As Integer
            '
            With frmMain
                For arrIndex = 0 To (.lstUserStorage(Index).ListCount - 1)
                    If LenB(.lstUserStorage(Index).List(arrIndex)) Then
                    'if not null entry
                        userSplit() = Split(.lstUserStorage(Index).List(arrIndex), ACross)
                        If UBound(userSplit) > 5 Then
                        'if proper ubound
                            userSplit(0) = Mid$(userSplit(0), 2)
                            'parse past the indicator
                            IndexLoc = InList(APointer & userSplit(0) & ACross, .lstIdleTicks(Index), False)
                            If IndexLoc <> -1 And userSplit(6) <> 0 Then
                                StringLoc = InStr(.lstIdleTicks(Index).List(IndexLoc), ACross)
                                If StringLoc <> 0 Then
                                'if found value
                                    idleTick = Val#(Mid$(.lstIdleTicks(Index).List(IndexLoc), StringLoc + 1))
                                    'set
                                    If idleTick <> 0 Then
                                    'if a value is set
                                        aProfile(Index).ChannelUsers = aProfile(Index).ChannelUsers & APointer & userSplit(0) & ACross & userSplit(6) & AZero & idleTick & AOne
                                        'add to string
                                    End If
                                End If
                                '
                            End If
                            'if found in idle list
                        End If
                    End If
                    'not null entry
                Next arrIndex
            End With
        End If
        'set data
    Else
    'not last channel and not void
        aProfile(Index).ChannelUsers = vbNullString
        '
    End If
    'if last channel or void, the following will temporarily store in channel and idle ticks before clearing the
    'listboxes. this is so if the bot owner DCs, or rejoins, data isnt lost

    If Left$(LCase$(theChannel), 5) = "clan " Then
        aProfile(Index).ChannelClanTag = LCase$(Mid$(LCase$(theChannel), 6))
    Else
        aProfile(Index).ChannelClanTag = vbNullString
    End If
    'stores the tag of the channel this profile is in, if its a clan channel
    
    aProfile(Index).SpamGuardErrorMessage = vbNullString
    aProfile(Index).OperatorList = vbNullString
    aProfile(Index).IdleUsersGrayed = vbNullString
    aProfile(Index).Operator = False
    frmMain.lstGreetedUsers(Index).Clear
    frmMain.lstIdleTicks(Index).Clear
    frmMain.lstUserStorage(Index).Clear
    aProfile(Index).ManualEntryTick = GTC
    'clear
    aProfile(Index).RealPing = thePing
    'sets ping of yourself
    If Index = botElements.ActiveChatIndex Then frmMain.lvUserlist.ListItems.Clear
    'clears userlist
    Modify_UserlistSelection False
    'clear backing
    If theChannel = "The Void" Then
        If aProfile(Index).QueueRaiseFactor < 60 Then aProfile(Index).QueueRaiseFactor = aProfile(Index).QueueRaiseFactor + 1
        'bump raise factor
        frmMain.lstQueueData(Index).Clear
        'clears the queue
        aProfile(Index).QueueWaitTick = aProfile(Index).QueueWaitTick + 5000
        'add minor delay before casting rejoin
        QueueString "/j " & aProfile(Index).Channel & Auto000, Index
        'queue to instantly rejoin channel
        SetTimer frmMain.hwnd, 8, 11000, AddressOf rejoinHome
        'issue rj timer
    Else
        aProfile(Index).ChannelHome = theChannel
        'set new home channel for reconnect
        aProfile(Index).FilterResetTick = 0
        'reset filters if not the void
    'if not the void then
    End If
    'rejoin
    aProfile(Index).Channel = theChannel
    'sets channel currently in for profile
    If Index = botElements.ActiveChatIndex Then
        updateFrmMainCaption Index
        'update the form title
        Set_ChannelCaption True
        'update to channel joined and count
    Else
        If aProfile(Index).Channel <> aProfile(botElements.ActiveChatIndex).Channel And (GTC - aProfile(Index).UptimeTick) > 1000 Then handleNewChatIconChange aProfile(Index).ChatIconChanged, Index
        'update the icon
    End If
    'display
    
    AddChat 0, Index, &HA09E5F, GetString(7), &HC1FFC1, theChannel, &HA09E5F, " with a ping of ", &HC1FFC1, thePing, &HA09E5F, " --" '-- You have joined
    'add chat at bottom so all changes are made, so profile preview displays it
    
    
End Sub
'called when YOU join a channel

Private Sub rejoinHome()
Dim arrIndex As Integer

    Dim enableTimer As Boolean
    'timer is set, dont issue again
    KillTimer frmMain.hwnd, 8
    'destroy timer
    For arrIndex = 0 To UBound(aProfile)
        If aProfile(arrIndex).Connected Then
        'if profile is connected check
            If aProfile(arrIndex).Channel = "The Void" Then
                QueueString "/j " & aProfile(arrIndex).ChannelHome & Auto000, arrIndex
                'set to join home
                enableTimer = True
            End If
        End If
    Next arrIndex
    
    If enableTimer Then SetTimer frmMain.hwnd, 8, 11000, AddressOf rejoinHome
    'start timer again
    
End Sub
'attempts to join home channel if bot is voided

Private Function handleCELeave(ByVal theName As String, ByVal thePing As Long, ByVal FlagUpdate As Boolean, ByVal Index As Integer) As Integer
On Error GoTo Err
    
    RemoveD2Char theName, Index
    '
    handleCELeave = InList(APointer & theName & ACross, frmMain.lstUserStorage(Index), False)
    'locates spot in userlist
    If Not FlagUpdate Then
        'if not flag update
        If InStrB(aProfile(Index).OperatorList, ACross & theName & ASnake) Then
            aProfile(Index).OperatorList = Replace$(aProfile(Index).OperatorList, ACross & theName & ASnake, vbNullString)
            'removes from operator list if in it, if not just a flag update
            aProfile(Index).FilterSafeName = theName
            'this variable is byref so we can take this from ceflags and pass it to cejoin
        End If
        'remove from op list if in it
        If Not FilteredItem(theName, vbNullString, 1, Index, thePing) Then
            If botElements.JoinLeaves Then AddChat 0, Index, &H8000&, theName, vbGreen, " has left the channel"
            'add chat
            HandleGreet False, theName, thePing, Index, 0
            'sends greet if enabled
        End If
        'if not filtered
    Else
        Dim flagSplit() As String, userString As String
        '
        If handleCELeave <> -1 Then
            userString = frmMain.lstUserStorage(Index).List(handleCELeave)
            flagSplit = Split(userString, ACross)
            'splits into client name ect
            aProfile(Index).FlagUpdateTick = flagSplit(6)
            'sets the old time the user has been in the channel
        'if found in list
        End If
    End If
    'add chat
        
    If handleCELeave <> -1 Then
    'if a flag update
        frmMain.lstUserStorage(Index).RemoveItem handleCELeave
        'remove from storage
        If Not FlagUpdate Then Set_IdleTick theName, Index, True, -1
        'remove from idle list
    End If
    'if found in list then remove
    Set_UserlistUpdate Index, False, False
    'update userlist

Err:
    If Err.Number <> 0 Then handleProjectError Index, "Error:function|handleCELeave -> [" & Err.Number & "] " & Err.Description
End Function
'called when a user leaves a channel or flag update (made function to grab index user is

Public Sub DisableFilters(ByRef Index As Integer, ByRef HaltUnCP As Boolean)
    aProfile(Index).FilterTriggered = False
    aProfile(Index).FilterRandomJoins = 0
    aProfile(Index).FilterRandomTick = 0
    aProfile(Index).FilterResetTick = 0
    '
    'AddChat 0, Index, vbYellow, GetSTRING(216)
    If Index = botElements.ActiveChatIndex Then Set_ComboPrev "Active Ping: " & botElements.ActivePing & Space$(10) & "Filtered Items: " & aProfile(Index).FilterCount & Space$(10) & "Automatic Filters [ " & FiltersEnabledResponse(Index) & " ]", True
    'only update if same index
    'String216=Chat filters have been [ Disabled ].
    If aProfile(Index).AutoCP And aProfile(Index).Operator And Not HaltUnCP Then
    'if auto cp is enabled
        QueueString CPOff, Index
        'if has been more than 1 second since this was called
    End If
End Sub
'disables filters and announces

Public Function FilteredItem(ByVal theName As String, ByVal theMessage As String, ByRef theID As Integer, ByRef Index As Integer, Optional ByRef thePing As Long, Optional ByRef theFlags As Long, Optional ByRef theAccess As Integer) As Boolean
Dim theTick As Currency
Dim RandomJoin As Boolean
Static banName As String
'if true the user has been detected

    '0 join 1 leave 2 talk/emote/whisper 3 info_msg
    If theID = 1 Or theID = 0 Then
    'if join or leave
        If LenB(aProfile(Index).FilterSafeName) Then
        'if safe name exist
            If theName = aProfile(Index).FilterSafeName Then
                Exit Function
            'safe name dont check filters
            Else
            'not a match clear safe name
                aProfile(Index).FilterSafeName = vbNullString
            End If
        End If
    End If
    'check if safe name
    theTick = GTC
    '
    If aProfile(Index).FilterTriggered Then
    'if filters are enabled ...
        If theTick - aProfile(Index).FilterResetTick > 120000 Then
        'if enough time has passed since last filtered item then disable filters
            DisableFilters Index, False
        Else
        'if not reset
            If LenB(theName) Then
            'if name isnt null then check if it was the last filtered name
            'dont run this check if channel list update
                Dim tmpName As String
                tmpName = RemoveFirstStar(detachRealm(theName, Index))
                'set name w/o realm
                If botElements.FiltersLastName = tmpName Then
                'if name matches last name
                    If theTick - botElements.FiltersLastTick < 2000 Then
                    'if within 2 seconds of last check
                        FilteredItem = True
                        'filter it
                        Select Case theID
                            Case 1, 2
                                aProfile(Index).FilterResetTick = theTick
                            'reset if leave or talk within 2 seconds of last check on this user
                        End Select
                        '
                        theID = -1
                    End If
                    'set as filter and change theID so it doesnt do checks
                End If
            'if name isnt null
            End If
        End If
        'reset, no flood for x time
    Else
    'filters arent yet enabled
        If LenB(banName) <> 0 Then If Left$(theName, Len(banName)) <> banName Then banName = vbNullString
        'reset
    End If

    Select Case theID
        Case 0 'join
            If aProfile(Index).FilterTriggered Then
            'if filters are enabled
                If theName = aProfile(Index).FilterJoinName And theTick - aProfile(Index).FilterJoinTick < 500 Then
                    Dim joinerNotWarcraft As Boolean
                    Dim StringLoc As Integer
                    StringLoc = InStrB(theName, "#")
                    Dim DuplicateName As Boolean
                    Dim RealmIncluded As Boolean
                    
                    If (IsNumeric(Mid$(theName, StringLoc + 1, 1))) Then
                        Dim StringLoc2 As Integer
                        StringLoc2 = InStrB(Mid$(theName, StringLoc + 1), "#")
                        If (StringLoc2 > 0) Then
                            RealmIncluded = True
                        End If
                        DuplicateName = True
                    Else
                        RealmIncluded = True
                        DuplicateName = False
                    End If
                    '
                    If aProfile(Index).GameClient = Str_3RAW Or aProfile(Index).GameClient = Str_PX3W Then
                    'if is warcraft profile
                        
                        If (RealmIncluded) Then joinerNotWarcraft = True
                        'if has realm tag then joiner isnt w3 user
                    Else
                    'if profile isnt on w3
                        If (RealmIncluded = False) = 0 Then joinerNotWarcraft = True
                    End If
                    'check if the user is using w3 or not
                    If joinerNotWarcraft Then
                        FilteredItem = True
                        'block msg
                        If get_Access(theName, Index) = 0 Then
                            Dim tmpConversion As String
                            tmpConversion = FirstNameConversion(theName, Index)
                            frmMain.lstFilteredNames.AddItem APointer & tmpConversion & ACross
                            'filter
                            AddChat 0, Index, vbYellow, GetString(113) & tmpConversion & GetString(182)
                            'String182=] has been detected as a flood and has been name filtered. If this was a mistake add the user with 1 access and unfilter them.
                        End If
                        'filter the name during this bot session if no access
                    End If
                    'only do this if they arent a war3 client
                'if two fast joins
                Else
                    If botElements.FiltersDisableJoinLeaves Then FilteredItem = True
                    'if hide all joins and leaves
                    '
                    GoTo FilteredItem_Case0_1
                    'see if need to squelch
                End If
            'if filters r enabled alrdy
            Else
            'if filters arent enabled yet
FilteredItem_Case0_1:
                If numberInName(theName, Index) Then
                    FilteredItem = True
                    If aProfile(Index).FilterTriggered Then aProfile(Index).FilterResetTick = theTick
                'if the user joining is a clone#3 or higher
                ElseIf isRandomName_Join(theName, thePing, theMessage, theFlags, Index, theAccess) Then
                'if name is detected as random then mark the random join count up one
                    FilteredItem = True
                End If
                'check if to filter
            End If
        'join
        Case 1 'leave
            If aProfile(Index).FilterTriggered Then
            'if filters enabled
                If theName = aProfile(Index).FilterJoinName And theTick - aProfile(Index).FilterJoinTick < 500 Then
                    FilteredItem = True
                'if left after joining quickly
                ElseIf botElements.FiltersDisableJoinLeaves Then
                    FilteredItem = True
                    'if hide all joins and leaves\
                End If
            End If
            'if filters are enabled
            If Not FilteredItem Then
            'if not yet filtered
                If numberInName(theName, Index) Then
                    FilteredItem = True
                'if the user joining is a clone#3 or higher
                ElseIf newToChannel(theName, Index, False, -1, theTick) Then
                    If LenB(banName) <> 0 Then
                        If Left$(theName, Len(banName)) <> banName Then FilteredItem = True
                    Else
                        RandomJoin = True
                    'no ban name stored, filter
                    End If
                'if leaving quickly after joining, and is not a user of the most recent ban
                ElseIf isRandomName_Leave(theName, Index) Then
                    RandomJoin = True
                'if name is detected as random then mark the random join count up one
                End If
            End If
            'if not yet filtered
            If RandomJoin And aProfile(Index).FilterTriggered Then FilteredItem = True
            'if is a random join and filters are on. if filters arent on yet just add to the random join tally
        'leave
        Case 2 'talk emote whisperfrom
            If newToChannel(theName, Index, True, -1, theTick) Then
            'if talked too soon within joining the channel filter (500ms if filters arent enabled, 3000ms if they are)
                FilteredItem = True
            End If
            If botElements.FiltersBlockDuplicates And Not FilteredItem Then
            'if their name is a clone higher than 2, or if filters are enabled clone at all
                If numberInName(theName, Index) Then FilteredItem = True
                'if has clone#3 in name 3 or higher
            End If
            If theFlags = -2 And Not FilteredItem Then
            'if a whisper from do whisper flood checks
            'how this works:
                'every whisper received within 1 second of another registers as a threat.
                'when the threat lvl reaches 10 or higher whispers are filtered and if not already, triggers are enabled.
                'once triggers are enabled whispers become blocked if threat count is above 2.
                'to be above threat count two this would require no whispers for a minimum of 14 seconds.
                'you can still get whispers with filters enabled but only if the threat count is 2 or less.
                'this does potentially still allow spam coming in once every 2-4 seconds in the form of the whisper but
                'the bot will maintain stability. user should be expected to go /dnd or o igw as whispers are nearly impossbile
                'to detect if from person or bot.
                Dim WhisperTickDifference As Currency
                WhisperTickDifference = theTick - aProfile(Index).FilterWhisperTick
                'subtract from this variable to determine how long has passed since last whisper
                If WhisperTickDifference < 1000 Then
                    If aProfile(Index).FilterWhisperCount < 11 Then aProfile(Index).FilterWhisperCount = aProfile(Index).FilterWhisperCount + 1
                End If
                'received a whisper within 1s of last whisper, raise 1 count if not over count limit
                
                Do Until aProfile(Index).FilterWhisperCount < 1 Or WhisperTickDifference < 2000
                    aProfile(Index).FilterWhisperCount = aProfile(Index).FilterWhisperCount - 1
                    'remove 1 filter mark
                    If aProfile(Index).FilterTriggered Then
                        WhisperTickDifference = WhisperTickDifference - 2000
                        'takes a max of 20 seconds for filters to cool down
                        'only this high if filters are triggered
                    Else
                        WhisperTickDifference = WhisperTickDifference - 1000
                        'minus 1000 (less strict) if filters arent yet enabled
                    End If
                    'to disable.
                Loop
                'subtrack ticks
                
                If aProfile(Index).FilterTriggered Then
                    If aProfile(Index).FilterWhisperCount > 2 Then
                        FilteredItem = True
                        aProfile(Index).FilterResetTick = theTick
                    End If
                'filters are enabled and are receiving whispers too frequently then filter item
                'reset last filteed item tick as well
                Else
                'filters not yet triggered
                    If aProfile(Index).FilterWhisperCount > 9 Then FilteredItem = True
                    'if at 10 count then filter item
                End If
                '
                aProfile(Index).FilterWhisperTick = theTick
                'reset tick
            End If
        'talk emote whisperfrom
        Case 3
            If aProfile(Index).FilterTriggered Then
                If InStrB(theMessage, " was kicked ") Or InStrB(theMessage, " was banned ") Then
                    If aProfile(Index).FilterHideBans Then FilteredItem = True
                End If
            'if filters are enabled
            Else
                If InStrB(theMessage, " was kicked ") Or InStrB(theMessage, " was banned ") Then banName = Left$(theMessage, InStr(2, theMessage, ASpace) - 1)
                'was a kick or ban, check if it needs to be filtered
                'set name banned. this is global for whole bot but the chances of this creating conflict are slim
            End If
        'info, kick or ban
    End Select
    
    If RandomJoin Then
    'if detected as random and filters are not yet enabled
        If aProfile(Index).FilterTriggered Then
            FilteredItem = True
        'automatically filter is automatic filters are enabled
        Else
        'auto filters arent on
            Dim ljTick As Currency
            ljTick = theTick - aProfile(Index).FilterRandomTick
            'set
            If ljTick < 15000 Then
                aProfile(Index).FilterRandomJoins = aProfile(Index).FilterRandomJoins + 1
                'increase 1
                If ljTick < 2000 Then aProfile(Index).FilterRandomJoins = aProfile(Index).FilterRandomJoins + 1
                'was really recent within each other, increase again
                If aProfile(Index).FilterRandomJoins > 8 Then
                    FilteredItem = True
                    aProfile(Index).FilterRandomJoins = 8
                End If
                'if above limit trigger filters
            'random user has joined or left within the time period
            Else
                aProfile(Index).FilterRandomJoins = 1
            'past count, reset
            End If
            aProfile(Index).FilterRandomTick = theTick
            'reset tick
        End If
    End If
    'if 4 instances of random name detection within x seconds then trigger filters
    
    Dim manualFilter As Boolean
    If Not FilteredItem And theID <> -1 Then
        Dim arrIndex As Integer, arrText As String, truncName As String
        '
        truncName = RemoveFirstStar(LCase$(FirstNameConversion(theName, Index)))
        'remove # but keep realm
        If theID < 3 Or theID = 4 Then
        'if join, leave, or talk
            If InList(APointer & truncName & ACross, frmMain.lstFilteredNames, False, False) <> -1 Then
                FilteredItem = True
            'name filter check. this applies for join leave talk emote whisperfrom and info
            Else
                If Not RandomJoin Then 'if not detected as random and is a join
                    If theID = 0 Or theID = 1 Then
                    'if join or leave
                        aProfile(Index).FilterJoinName = theName
                        aProfile(Index).FilterJoinTick = theTick
                    End If
                'set join tick and name
                End If
                'if neither check picked it up as a random then set the name as last join name
                'to check for 2 fast joins
            End If
        'if anything but a ban
        End If
        
        If theID = 2 And Not FilteredItem Then
        'message filter check. this applies for talk emote whisperfrom
            For arrIndex = 0 To UBound(botElements.FiltersInMessages)
                arrText = botElements.FiltersInMessages(arrIndex)
                'set filter being checked to variable
                If LenB(arrText) Then
                'if text isnt null
                    If InStrB(LCase$(theMessage), arrText) Then
                        FilteredItem = True
                        Exit For
                    End If
                    'match found
                'if text isnt null
                End If
            Next arrIndex
        'if theId is 2
        End If
        
        If FilteredItem Then manualFilter = True
        'if the data was filtered via manual filters then set manual filter to true, so we know not to
        'trigger auto filters, as it only triggers on auto detects
    'if data isnt filtered by auto checks run through manual filters
    End If


    If FilteredItem Then
        If aProfile(Index).FilterCount > 2147483600 Then
            AddChat 0, Index, vbYellow, GetString(222)
            'String222=Dang, your filters are working hard! Let me reset that for you...
            aProfile(Index).FilterCount = 0
        End If
        'wow.. reset filters
        aProfile(Index).FilterCount = aProfile(Index).FilterCount + 1
        'increase the count of filtered items, this will display with the act-ive ping
        If Not manualFilter Then
            If aProfile(Index).FilterResetTick = 0 Then
                If aProfile(Index).Operator And aProfile(Index).GuardLoadBan Then LoadbanCleanChannel Index, 60000
                'if bot is mod and load ban is on attempt to clean the channel
                aProfile(Index).FilterTriggered = True
                'enable
                'AddChat 0, Index, vbYellow, GetSTRING(59) 'String59=Chat filters have been automatically [ Enabled ].
                If Index = botElements.ActiveChatIndex Then Set_ComboPrev "Active Ping: " & botElements.ActivePing & Space$(10) & "Filtered Items: " & aProfile(Index).FilterCount & Space$(10) & "Automatic Filters [ " & FiltersEnabledResponse(Index) & " ]", True
                'only update display if same index
                ''chat
                aProfile(Index).FilterResetTick = theTick
                'set tick
                If aProfile(Index).AutoCP And aProfile(Index).Operator Then
                'if auto cp is enabled
                    If theTick - Moderation.CPTick > 1000 Then
                        QueueString CPOn, Index
                        Moderation.CPTick = theTick
                    End If
                    'if has been more than 1 second since this was called
                End If
            'filters got kicked on
            Else
                If theID = 0 And LenB(tmpName) And tmpName <> botElements.FiltersLastName Then
                    botElements.FiltersLastName = tmpName
                    botElements.FiltersLastTick = theTick
                End If
                'update last name filtered
            'filters are already on
            End If
            'first enable
        End If
        'if auto filter then rese last filter tick, addc if applying auto filters and apply filter variable
    End If
    'if an item was filtered then

End Function
'if return true then dont add chat

Public Sub LoadbanCleanChannel(ByRef Index As Integer, ByRef theDelay As Long)
Dim listLoc As Integer
Dim userSplit() As String
Dim theAccess As Integer
Dim theName As String
Dim theTick As Currency

    theTick = GTC
    '
    Do Until listLoc = frmMain.lstUserStorage(Index).ListCount
        userSplit = Split(frmMain.lstUserStorage(Index).List(listLoc), ACross)
        'get info
        If UBound(userSplit) > 6 Then
        'which it always should be
            '6 time in channel tick, 7 filter mark
            theName = Mid$(userSplit(0), 2)
            'remove the pointer
            If userSplit(7) > aProfile(Index).GuardLevel Or numberInName(theName, Index) Then
            'if filter marks are greater than limit in place or if name has a # in their name continue on
                If newToChannel(theName, Index, False, theDelay, theTick) Then
                'if new to the channel within specified time
                    theAccess = get_Access(theName, Index)
                    'if access isnt supplied then grab it
                    If theAccess = 0 Then QueueString ABan & AttachRealmSingle(theName, Index) & " CC" & Auto000, Index
                    'issue the ban if no access
                End If
                'if has joined channel within x seconds
            End If
            'if filter mark is more than guard lvl
        End If
        'if proper ubound
        listLoc = listLoc + 1
    Loop

End Sub
'cleans channel of potential loads when filters are triggered

Private Function readNamePoints(ByRef theName As String, ByRef Index As Integer) As Integer
Dim listLoc As Integer

    listLoc = InList(APointer & theName & ACross, frmMain.lstUserStorage(Index), False)
    If listLoc <> -1 Then
    'if found
        Dim lstSplit() As String
        lstSplit = Split(frmMain.lstUserStorage(Index).List(listLoc), ACross)
        'split it!
        If UBound(lstSplit) > 6 Then readNamePoints = lstSplit(7)
        'if proper ubound then
    End If

End Function
'reads how many points have been assigned to this name

Private Function CalculateFilterMarks(ByVal theName As String, ByRef thePing As Long, ByRef theMessage, ByRef theFlags, ByRef Index As Integer) As Integer
    
    Dim bonusMarks As Byte
    'for each infraction, they are increased this value
    'only used in certain circumstances
    
    theName = RemoveFirstStar(detachRealm(theName, Index))
    'sets name we will be checking for variation
    
    Dim StringLoc As Integer
    '
    Dim arrIndex As Integer, charAsc As Byte
    Dim AscCurrent As Byte, AscLast As Byte
    Dim caseUpper As Byte, caseNumber As Byte
    '
    For arrIndex = 1 To Len(theName)
        charAsc = AscW(Mid$(theName, arrIndex, 1))
        'gets the asc code for the first left char
        If charAsc < 48 Or charAsc > 122 Then
            CalculateFilterMarks = CalculateFilterMarks + 3
            AscCurrent = 0
            GoTo isRandomName_ASC_Found
        End If
        'special chars part 1
        If charAsc > 90 And charAsc < 97 Then
            CalculateFilterMarks = CalculateFilterMarks + 3
            AscCurrent = 0
            GoTo isRandomName_ASC_Found
        End If
        'special chars part 2
        If charAsc < 58 And charAsc > 47 Then
            CalculateFilterMarks = CalculateFilterMarks + 3
            caseNumber = caseNumber + 1
            AscCurrent = 1
            GoTo isRandomName_ASC_Found
        'numbers
        ElseIf charAsc > 64 And charAsc < 91 Then
            CalculateFilterMarks = CalculateFilterMarks + 3
            caseUpper = caseUpper + 1
            AscCurrent = 2
            GoTo isRandomName_ASC_Found
        'uppercase
        ElseIf charAsc > 96 And charAsc < 123 Then
            AscCurrent = 3
            GoTo isRandomName_ASC_Found
        'lowercase
        End If
        'adds how many of each character type, and sets the thisCase variable -- which just stores which type the current
        'letter is
isRandomName_ASC_Found:
        If AscCurrent <> AscLast Then
            CalculateFilterMarks = CalculateFilterMarks + 2
        'if alternating case
        ElseIf AscCurrent = AscLast And AscCurrent = 2 Then
            CalculateFilterMarks = CalculateFilterMarks + 2
        'if last and this char is caps
        End If
        '
        AscLast = AscCurrent
        'if alternating cases then add 0.3 of a point
    Next arrIndex
    'disect string
    
    If thePing < 1 Then
        bonusMarks = bonusMarks + 2
        CalculateFilterMarks = CalculateFilterMarks + 6
    'negative or 0
    Else
        If thePing > 2400 Then thePing = 2400
        'forces max + 24 points for ping
        If thePing > 400 Then
            bonusMarks = bonusMarks + 2
        'high ping
        ElseIf thePing < 100 Then
            CalculateFilterMarks = CalculateFilterMarks - 5
        'low ping
        End If
        CalculateFilterMarks = CalculateFilterMarks + Int(thePing / 100)
    'add point for high ping
    End If
    'checks ping
   
    If caseUpper = 1 And Left$(theName, 1) <> UCase$(Left$(theName, 1)) Then
        bonusMarks = bonusMarks + 1
        CalculateFilterMarks = CalculateFilterMarks + 10
    'if has uppercase and isnt the first char
    ElseIf caseUpper = 0 And caseNumber <> 0 Then
        bonusMarks = bonusMarks + 2
        CalculateFilterMarks = CalculateFilterMarks + 10
    'all lowercase and has numbers
    ElseIf caseUpper = 0 And caseNumber = 0 Then
        bonusMarks = bonusMarks + 3
        CalculateFilterMarks = CalculateFilterMarks + 10
    'all lowercase and no numbers
    End If
    
    If botElements.FiltersClientDeductable Then If InStrB(theMessage, Str_PX2D) Or InStrB(theMessage, Str_PX3W) Or InStrB(theMessage, Str_3RAW) Then CalculateFilterMarks = CalculateFilterMarks - 10
    'if d2xp or war3 or w3xp then remove 10 filter marks
    
    If theFlags = 16 Then CalculateFilterMarks = CalculateFilterMarks + 6 + bonusMarks
    'has plug
        
    If InStrB(theMessage, "0 0 0 0 0 0 0 0") Then
        CalculateFilterMarks = CalculateFilterMarks + 3 + bonusMarks
    ElseIf Left$(theMessage, 4) = Str_PXES Or Left$(theMessage, 4) = Str_RATS Then
        Dim statSplit() As String
        statSplit = Split(theMessage, ASpace)
        If UBound(statSplit) > 5 Then CalculateFilterMarks = CalculateFilterMarks - 5
    'if not no stats then split message, if has more than 5 wins then remove 5 marks
    ElseIf InStrB(theMessage, "3RAW 1R3W 0") Then
        CalculateFilterMarks = CalculateFilterMarks + 3 + bonusMarks
    End If
    'no stats sc or w3
    
    If caseNumber > 1 Then CalculateFilterMarks = CalculateFilterMarks + caseNumber
    'if more than 1 number in name
    If caseUpper > (Len(theName) / 4) Then CalculateFilterMarks = CalculateFilterMarks + 7
    'if name is 25% or more of uppercase letters
    CalculateFilterMarks = CalculateFilterMarks + Len(theName)
    'adds points based on length of the name
    
    CalculateFilterMarks = (CalculateFilterMarks - 25)
    'remove allowed infractions

End Function
'gets the filter marks for this name

Private Function isRandomName_Join(ByRef theName As String, ByRef thePing As Long, ByRef theMessage, ByRef theFlags, ByRef Index As Integer, ByRef theAccess As Integer) As Boolean

    If theFlags = 32 Or theFlags = 48 Then
        isRandomName_Join = True
        Exit Function
    End If
    'user is ignored and is not rep or op
    
    Dim FilterMark As Integer
    FilterMark = readNamePoints(theName, Index)
    'gets
    If FilterMark > 0 Then
        If aProfile(Index).FilterTriggered Then
        'if auto filters are on and point value is extremely high then ignore.
        'joins check access for misc uses, so if access = -1 we can assume it wasnt checked, and is not a join.
            isRandomName_Join = True
            '
            Dim thisTick As Currency
            If FilterMark > 45 And aProfile(Index).FilterResetTick <> 0 Then
                thisTick = GTC
                aProfile(Index).FilterResetTick = thisTick
            End If
            'reset the tick if high filter mark and if filters are already enabled
            'max threat lvl is 40 so 45 should be considered high enough to filter
            'store tickcount to be used later with auto squelching
            If Not aProfile(Index).Operator Then
            'not a moderator, check into squelching while idle
                If FilterMark > 40 And botElements.FiltersSquelchLoads Then
                'only autoignore if really high threat level
                    If theAccess = -1 Then theAccess = get_Access(theName, Index)
                    'if access isnt supplied then grab it
                    If theAccess = 0 And Not aProfile(Index).AutoSquelchQueued Then
                    'if no access and currently not an auto squelch in queue for this profile
                        If (thisTick - aProfile(Index).ManualEntryTick) > 60000 Then
                        'if last time a manual entry was done such as chat or a remote command it should be okay to start ignoring
                            aProfile(Index).AutoSquelchQueued = True
                            QueueString ASquelch & theName & Auto000, Index
                        End If
                    End If
                    'old method, may come back to this
                End If
                'if not a mod
            End If
        'if high dtection rate and filters r enabled
        Else
        'if filters arent enabled yet
            If FilterMark > 13 Then isRandomName_Join = True
            'marks higher than 13 are moderate threat, so raise count
        End If
    Else
    'less than mark count
        If thePing < 1 Or thePing > 499 Then isRandomName_Join = True
        'if no or high ping then also random name, but dont check to ignore
    End If
    
    

End Function
'checks if a name is random upon join

Private Function isRandomName_Leave(ByRef theName As String, ByRef Index As Integer)

    Dim FilterMark As Integer
    FilterMark = readNamePoints(theName, Index)
    'grab
    If FilterMark > 0 And aProfile(Index).FilterTriggered Then isRandomName_Leave = True
    'if greater than mark then
    
End Function
'checks if a name is random upon leave


Public Function numberInName(ByVal theName As String, ByVal Index As Integer) As Boolean
Dim StringLoc As Integer
    
    
    StringLoc = InStr(theName, "#")
    If StringLoc <> 0 Then
        If IsNumeric(Mid$(theName, StringLoc + 1, 1)) Then
            If aProfile(Index).FilterTriggered Then
            'if filters are already triggered then any # will be filtered
                numberInName = True
                'set
            Else
                'removes name and gets the digits past the # symbol
                theName = detachRealm(theName, Index)
                'if #realm in name remove it
                If Val#(theName) > 2 Then numberInName = True
                'if filters arent triggered only number sabove 2 will be true
            End If
        End If
    End If

End Function
'determines if the name has a # in it, and if so extracts the number

Private Function newToChannel(ByRef theName As String, ByRef Index As Integer, ByRef checkChat As Boolean, ByVal setDelay As Long, ByRef theTick As Currency) As Boolean
Dim listIndex As Integer
Dim listSplit() As String

    '0 13 22 guard levels
    listIndex = InList(APointer & theName & ACross, frmMain.lstUserStorage(Index), False)
    If listIndex <> -1 Then
    'if name is in user list
        listSplit = Split(frmMain.lstUserStorage(Index).List(listIndex), ACross)
        'found user, set the time theyve been in channel
    Else
        Exit Function
    'couldnt find user
    End If
    
    Dim tickAmount As Long
    '
    If setDelay = -1 Then
        If aProfile(Index).FilterTriggered Then
            If checkChat Then
                Dim extraDelay As Long
                'amount of extra time to require per mark above 0
                extraDelay = (listSplit(7) * 500)
                If extraDelay > 10000 Then extraDelay = 10000
                'if user is chatting and filters are enabled then determine how long to block
                'their messages based off their filter mark count, max of 10 seconds.
                tickAmount = 3000 + extraDelay
            Else
                tickAmount = 60000
            'dont show leave if within 60 seconds of joining and if filters are enabled
            End If
        Else
            tickAmount = 500
            'if a flood hasn't been triggered then 500ms
        End If
        'minimum time the user must be in the channel for their text to show up
    Else
        tickAmount = setDelay
    'use a specified time
    End If
    If (theTick - listSplit(6)) < tickAmount Then newToChannel = True


End Function
'if returned true the name has been in the channel for less than 5 seconds

Public Sub RemoveD2Char(ByRef theName As String, ByRef Index As Integer)
    
    If aProfile(Index).GameClient = Str_PX2D Or aProfile(Index).GameClient = Str_VD2D Then
    'only check profile is on d2 client
        Dim StarLoc As Byte
        StarLoc = InStr(2, theName, AStar)
        If StarLoc <> 0 Then theName = Mid$(theName, StarLoc + 1)
    End If

End Sub
'removes text prior to the *bnetName for d2 clients only

Private Sub handleCEJoin(ByVal theName As String, ByRef theMessage As String, ByRef thePing As Long, ByRef theFlags As Long, ByRef addIndex As Integer, ByRef EntryType As Byte, ByRef Index As Integer)
Dim FilteredData As Boolean
Dim joinTick As Currency
Dim theTick As Currency
Dim theAccess As Integer

    'If frmMain.lstUserStorage(Index).ListCount > 499 Then Exit Sub
    'truncuate list to prevent lag

    RemoveD2Char theName, Index
    '
    If EntryType = 1 And aProfile(Index).AutoCP And aProfile(Index).Operator And aProfile(Index).FilterTriggered Then
        DisableFilters Index, True 'disable filters but dont uncp
    End If
    'if someone joined while we thought cp was on then reset filters
    
    'EntryType
    '0 newChan  1 Join  2 flag update
    Dim CompileString As String, GetClientResponse As String, theSplit() As String, theClan As String
    Dim nameIndex As Integer
    'variables I may or may not use
    
    nameIndex = InList(APointer & theName & ACross, frmMain.lstUserStorage(Index), False)
    If nameIndex = -1 Then
    'if not in the channel list yet
        GetClientResponse = GetClient(theMessage, theFlags, theName, Index)
        'we do this so we know wether to add top the top of the list or not, operator/rep
        theSplit() = Split(GetClientResponse, ACross)
        'split(0) T/F[for top] ,  split(1) ?/clanTag  ,  split(2)  iconNumber  ,  split(3)  obtained-ops T/F  ,  split(4)  client-string
        If LenB(theSplit(1)) > 2 Then theClan = theSplit(1)
        '
        Select Case EntryType
            Case 0
                If LenB(aProfile(Index).ChannelUsers) Then
                'if ticks are stored
                    Dim StringLoc As Long
                    StringLoc = InStr(aProfile(Index).ChannelUsers, APointer & theName & ACross)
                    'only return old values if not the profile
                    If StringLoc <> 0 Then
                    'if the user is found then
                        Dim addValues As String
                        addValues = Mid$(aProfile(Index).ChannelUsers, StringLoc + 1)
                        'get name+ticks and rest of names
                        addValues = Left$(addValues, InStr(addValues, AOne) - 1)
                        'set name+ticks for a single name
                        addValues = Mid$(addValues, InStr(addValues, ACross) + 1)
                        'sets just ticks
                        If theName = aProfile(Index).RealName Then
                            joinTick = (GTC - 5001)
                            'if self reset in channel tick, since obv i just joined
                        Else
                            joinTick = Val#(Left$(addValues, InStr(addValues, AZero) - 1))
                        End If
                        'sets join tick
                        addValues = Mid$(addValues, InStr(addValues, AZero) + 1)
                        'sets idle tick
                    Else
                        joinTick = (GTC - 5001)
                    End If
                Else
                'ticks arent stored
                    joinTick = (GTC - 5001)
                End If
            'new chan
            Case 1
                joinTick = GTC
            'join
            Case 2
                If aProfile(Index).FlagUpdateTick <> 0 Then
                    joinTick = aProfile(Index).FlagUpdateTick
                    aProfile(Index).FlagUpdateTick = 0
                'use stored update tick
                Else
                    joinTick = (GTC - 5001)
                'no update tick stored.. use default
                End If
            'flag update
        End Select
        'determines the users join tick
        Dim filterDetection As Integer
        'used to store filter marks
        If EntryType = 0 Or LCase$(theSplit(1)) = aProfile(Index).ChannelClanTag Then
        'user (from you joining a channel)
        'only difference is we add everyone with 0 filter marks
            theAccess = 2
            'set so filters arent checked
            filterDetection = 0
            '
        Else
            filterDetection = CalculateFilterMarks(theName, thePing, theMessage, theFlags, Index)
        End If
        'determine access / filter detection rate
        CompileString = APointer & theName & ACross & theSplit(2) & ACross & GetPing(thePing, theFlags) & ACross & thePing & ACross & theSplit(1) & ACross & theSplit(4) & ACross & joinTick & ACross & filterDetection
        'username and client-icon# and ping-icon# and actual-ping and w3clan_or_? and client-string and TickCount and Filter Mark and Name-Converted
        If addIndex = -1 Or theSplit(3) = 1 Then
            frmMain.lstUserStorage(Index).AddItem CompileString, theSplit(0)
            'adds to specified slot
        'if no previous slot included, or has obtained ops
        Else
            frmMain.lstUserStorage(Index).AddItem CompileString, addIndex
            're-add to place removed from
        End If
        'where to re-add to
                
    'if not in userlist then add
    Else
    'if already in the userlist then apply as a flag update
        GetClientResponse = GetClient(theMessage, theFlags, theName, Index)
        'we do this so we know wether to add top the top of the list or not, operator/rep
        theSplit() = Split(GetClientResponse, ACross)
        'split(0) T/F[for top] ,  split(1) ?/clanTag  ,  split(2)  iconNumber  ,  split(3)  obtained-ops T/F  ,  split(4)  client-string
        If LenB(theSplit(1)) > 2 Then theClan = theSplit(1)
        '
        CompileString = APointer & theName & ACross & theSplit(2) & ACross & GetPing(thePing, theFlags) & ACross & thePing & ACross & theSplit(1) & ACross & theSplit(4) & ACross & joinTick & ACross & filterDetection
        'username and client-icon# and ping-icon# and actual-ping and w3clan_or_? and client-string and TickCount and Filter Mark and Name-Converted
        frmMain.lstUserStorage(Index).RemoveItem nameIndex
        'remove from list
        If theSplit(3) = 1 Then
            frmMain.lstUserStorage(Index).AddItem CompileString, theSplit(0)
            'adds to specified slot
        'has obtained ops
        Else
            frmMain.lstUserStorage(Index).AddItem CompileString, nameIndex
            're-add to place removed from
        End If
        Set_UserlistUpdate Index, True, False
        'where to re-add to
    End If
    
    'EntryType
    '0 newChan  1 Join  2 flag update
    '########################
    Dim listBannedLoc As Integer
    Select Case EntryType
        Case 0
            listBannedLoc = InList(LCase$(RemoveFirstStar(AttachRealmSingle(theName, Index))), frmMain.lstBannedUsers, True, False)
            If listBannedLoc <> -1 Then frmMain.lstBannedUsers.RemoveItem listBannedLoc
            'if in banned list remove because bot is just joining channel. if name in channel they cant possible be banned
            If LenB(addValues) = 0 Then
                If joinTick = 0 Then joinTick = (GTC - 5001)
                'this occurs when the user is already in the list, and checks are skipped
                'which only seems to occur when you join a channel while in a clan
                addValues = joinTick
                'if unset then set as join tick
            Else
            'if set
                If theName = aProfile(Index).RealName Then
                    Read_IdleDisplay GTC
                    'gray users
                    aProfile(Index).ChannelUsers = vbNullString
                    'dont need this any more
                End If
                'if the name is the profile, which should ALWAYS be last..force update the grayed users
            End If
            Set_IdleTick theName, Index, False, Val#(addValues)
            'add to idle list on new channel
            If (theFlags And 32) = 32 Then 'iggy flag
                If get_Access(theName, Index) <> 0 Then AutoUnignore theName, Index
            End If
            'if user is ignored check if they have access.
            'if they do unignore them
            CheckMail theName, Index
            'checks if they have mail for reg join and new chan
        Case 1
            theAccess = theAccess - 1
            'subtracts 1 so if were 0 would be -1, if were 2 would be 1. i set to 2 above if clan member
            Dim theClient As String
            If UBound(theSplit) = 4 Then theClient = theSplit(4)
            'set client to check against client ban
            Call PerformOperatorChecks(theName, theFlags, theClient, 15, Index, False, theAccess)
            'check typical operator functions
            If theAccess < 1 Then FilteredData = FilteredItem(theName, theMessage, 0, Index, thePing, theFlags, theAccess)
            'only determine is filtered if no access or access wasnt checked
            If Not FilteredData Then
                If botElements.JoinLeaves Then
                    If LenB(theClan) Then
                        AddChat 0, Index, &H8000&, theName, vbGreen, " has joined the channel using ", &H8000&, StrReverse$(Left$(theMessage, 4)), vbGreen, " with a ping of ", &H8000&, thePing, vbGreen, " in ", &H8000&, "Clan " & theClan
                    Else
                        AddChat 0, Index, &H8000&, theName, vbGreen, " has joined the channel using ", &H8000&, StrReverse$(Left$(theMessage, 4)), vbGreen, " with a ping of ", &H8000&, thePing
                    End If
                End If
                'add chat
                HandleGreet True, theName, thePing, Index, theFlags
                'sends greet if enabled
                Set_IdleTick theName, Index, False, joinTick
                'add to idle list
                CheckMail theName, Index
                'checks if they have mail for reg join and new chan
            'if not filtered, autos or not
            End If
            '
        'if join then add chat and handle greet
        Case 2
        'flag update
            theAccess = -1
            'default
            If aProfile(Index).Operator Then
            'if are operator
                theTick = GTC
                If theTick - aProfile(Index).ModLastTick > 5000 Then aProfile(Index).ModLastName = vbNullString
                'if been 5 seconds since last mod check reset name
                If theName <> aProfile(Index).ModLastName Then
                'if not last name checked
                    aProfile(Index).ModLastName = theName
                    aProfile(Index).ModLastTick = theTick
                    'set values
                    theAccess = get_Access(theName, Index)
                    If theAccess = 0 Then
                    'if user has no access
                        If (theFlags And 32) = 32 Then
                            QueueString ABan & AttachRealmSingle(theName, Index) & " IP" & Auto000, Index
                        'if ipban
                        End If
                    End If
                'if not last name checked
                End If
            End If
            'if is an operator check various things
        'flag update
    End Select
    '#######################
    'im doing an entry type check again because id rather do it after the name
    'has been submitted to the listbox and such before doing a filter and add  chat check
    
    If theName = aProfile(Index).RealName Then
        Set_UserlistUpdate Index, True, False
        Call handleNewChatIconChange(aProfile(Index).ChatIconChanged, Index)
    Else
        If EntryType = 2 Then
            Set_UserlistUpdate Index, True, False
        Else
            Set_UserlistUpdate Index, False, False
        End If
    End If
    'set timer for userlist update
  
    If Err.Number <> 0 Then handleProjectError Index, "Error:sub|handleCEJoin -> [" & Err.Number & "] " & Err.Description
End Sub
'called when a user joins the channel

Public Sub PerformOperatorChecks(ByRef theName As String, ByRef theFlags As Long, ByRef theClient As String, ByRef ChannelIcon As Byte, ByRef Index As Integer, ByRef IgnoreBannedList As Boolean, ByRef theAccess As Integer)
Static LastShitAddTick As Currency
    
    If aProfile(Index).Operator Then
    'if are operator
        If Not IgnoreBannedList Then
            Dim listBannedLoc As Integer
            listBannedLoc = InList(LCase$(RemoveFirstStar(AttachRealmSingle(theName, Index))), frmMain.lstBannedUsers, True, False)
            If listBannedLoc <> -1 Then frmMain.lstBannedUsers.RemoveItem listBannedLoc
            'if in banned list remove because theyre joining channel
        End If
        'if not to ignore this part. this is only used for joins and not chans
        If theAccess < 1 Then
            Dim theTick As Currency
            theTick = GTC
            If theTick - aProfile(Index).ModLastTick > 5000 Then aProfile(Index).ModLastName = vbNullString
            'if been 5 seconds since last mod check reset name
            If theName <> aProfile(Index).ModLastName Then
            'if not last name checked
                aProfile(Index).ModLastName = theName
                aProfile(Index).ModLastTick = theTick
                'set values
                Dim TargetNameConverted As String, TargetNameWithoutNumber As String
                TargetNameConverted = AttachRealmSingle(theName, Index)
                TargetNameWithoutNumber = TruncNumber(TargetNameConverted)
                'makes it less work in the long run
                theAccess = get_Access(TargetNameWithoutNumber, Index)
                If theAccess = 0 Then
                'if user has no access
                    If (theFlags And 32) = 32 Then 'iggy flag
                        QueueString ABan & TargetNameConverted & " IP" & Auto000, Index
                        Exit Sub
                    Else
                        If ChannelIcon = ChannelIcon = 15 Then 'iggy icon 'since i only store the icon in the user list i have to check against the icon
                            QueueString ABan & TargetNameConverted & " IP" & Auto000, Index
                            Exit Sub
                        End If
                    End If
                    'if ipban
                    If aProfile(Index).Lockdown Then
                        QueueString ABan & TargetNameConverted & " LD" & Auto000, Index
                        Exit Sub
                    End If
                    'lockdown check
                    If LenB(theClient) Then
                        If InStrB(aProfile(Index).ClientBans, ACross & theClient & AStar) Then
                            QueueString ABan & TargetNameConverted & " CB" & Auto000, Index
                            Exit Sub
                        End If
                    End If
                    'cb check
                    If Shitlisted_User(TargetNameWithoutNumber, Index) Then
                        QueueString ABan & TargetNameConverted & " SL" & Auto000, Index
                        Exit Sub
                        'issue the ban
                    End If
                    'sl check
                    If aProfile(Index).GuardLoadBan Then
                    'if loadban is on
                        If numberInName(theName, Index) Then
                            QueueString ABan & TargetNameConverted & " LB" & Auto000, Index
                            'add ban to queue
                            Moderation.Shitlist(aProfile(Index).BNETRealm) = Moderation.Shitlist(aProfile(Index).BNETRealm) & AZero & LCase$(TargetNameWithoutNumber) & AOne
                            ''add to shtlist. doesn't save but does tmp add
                            Exit Sub
                        End If
                        'name has a # in it, ban
                    End If
                    'if number in name
                    If Tagbanned_User(TargetNameConverted, Index) Then
                        QueueString ABan & TargetNameConverted & " TB" & Auto000, Index
                        Exit Sub
                        'issue the queue, except make it an auto queue
                    Else
                        If numberInName(theName, Index) Then
                            If Tagbanned_User(TargetNameConverted, Index) Then
                                QueueString ABan & TargetNameConverted & " TB" & Auto000, Index
                                Exit Sub
                                'ban
                            End If
                        End If
                    'have to check with and without number for tagbans
                    End If
                    'tb check
                    If aProfile(Index).GuardLoadBan Then
                    'if load ban is enabled
                        Dim FilterMark As Integer
                        FilterMark = readNamePoints(theName, Index)
                        'get filter marks
                        If FilterMark > aProfile(Index).GuardLevel Then
                            QueueString ABan & TargetNameConverted & " LB" & Auto000, Index
                            Exit Sub
                        End If
                        'if higher than threat level ban
                    End If
                    'random name check
                End If
                'if has 0 access
            End If
            'if not last name checked
        End If
        'if less than 1 access(sometimes access comes in unset, so we check later)
    End If
    'if is an operator check various things

    


End Sub

Public Function Shitlisted_User(ByRef theName As String, ByRef Index As Integer) As Boolean
    
    If InStrB(Moderation.Shitlist(aProfile(Index).BNETRealm), AZero & LCase$(theName) & AOne) Then Shitlisted_User = True
    'if the lcase name is in the shitlist string per realm then
    
End Function
'shitlist are realm specific, not profile

Private Function Tagbanned_User(ByVal theName As String, ByRef Index As Integer) As Boolean
Dim tbSplit() As String, arrIndex As Integer

    tbSplit() = Split(Moderation.tagBans(aProfile(Index).BNETRealm), AOne)
    'split our tagbans
    theName = LCase$(theName)
    For arrIndex = 0 To (UBound(tbSplit) - 1)
        If WildCard_Match(theName, Mid$(tbSplit(arrIndex), 2)) Then
            Tagbanned_User = True
            Exit For
        End If
        'if match found exit loop
    Next arrIndex

    
End Function
'tagbans are realm specific, not profile
 
Private Sub CheckMail(ByVal theName As String, ByRef Index As Integer)
    
    theName = RemoveFirstStar(LCase$(FirstNameConversion(theName, Index)))
    '
    If InStrB(botElements.MailUsers(aProfile(Index).BNETRealm), APointer & theName & ACross) Then
    'if has mail
        If InStrB(botElements.MailNotified, APointer & theName & ACross) = 0 Then
        'if hasnt been notified too recently
            Dim FileNumber As Integer, fileData As String, MailConfirmed As Boolean
            FileNumber = FreeFile
            '
            Open App.Path & "\Text\Mail.txt" For Input As #FileNumber
            Do Until EOF(FileNumber)
                Line Input #FileNumber, fileData
                    If Left$(fileData, (Len(theName) + 2 + Len(ChangeRealmIndexToName(Index)))) = theName & "#" & ChangeRealmIndexToName(Index) & ACross Then MailConfirmed = True
            Loop
            Close #FileNumber
            'if the user is still in the mail txt then proceed, otherwise erase them from users with mail and exit sub
            If Not MailConfirmed Then
                botElements.MailUsers(aProfile(Index).BNETRealm) = Replace$(botElements.MailUsers(aProfile(Index).BNETRealm), APointer & theName & ACross, vbNullString)
                'remove
                Exit Sub
                'dont tell user
            End If
            'if the user is still in the mail txt then proceed, otherwise erase them from users with mail and exit sub
            botElements.MailNotified = botElements.MailNotified & APointer & theName & ACross
            'add to list
            If aProfile(Index).QueueRaiseFactor < 5 Then aProfile(Index).QueueRaiseFactor = aProfile(Index).QueueRaiseFactor + 9
            'raise the wait factor to help prevent against flooding out
            QueueString AWhisper & theName & ASpace & GetString(170) & Auto000, Index 'You have mail, type !read to view your inbox.
        End If
    End If

End Sub
'this sub just notifies the user that they have mail

Private Sub HandleGreet(ByRef JoinGreet As Boolean, ByRef theName As String, ByRef thePing As Long, ByRef Index As Integer, ByRef theFlags As Long)
Dim GreetMessage As String, theTick As Currency

    If (theFlags And 32) = 32 Then Exit Sub
    'dont greet ignored users

    If JoinGreet Then
        If LenB(aProfile(Index).GreetJoinMessage) = 0 Then Exit Sub
        'user joined. exit if there is no greet msg (suggesting join greet is disabled)
    Else
        If LenB(aProfile(Index).GreetLeaveMessage) = 0 Then Exit Sub
    End If
    'user left. exit if there is no greet msg (sugesting leave greet is disabled)
    
    If GTC - aProfile(Index).QueueWaitTick < 4000 Then Exit Sub
    'greets must wait 4 seconds after the delay of previous entry to send
    If frmMain.lstQueueData(Index).ListCount <> 0 Then Exit Sub
    'exit if queue already has entries
    
    Dim listLoc As Integer
    listLoc = InList(APointer & theName & ACross, frmMain.lstGreetedUsers(Index), False, False)
    '
    If listLoc <> -1 Then
    'if already in list
        Dim listData As String
        listData = frmMain.lstGreetedUsers(Index).List(listLoc)
        'stores user and their count
        If GTC - Val#(Mid$(listData, InStr(listData, ACross) + 1)) > 7200000 Then
        'has been over 2 hours, remove from list, readd, and greet
            frmMain.lstGreetedUsers(Index).RemoveItem listLoc
        Else
        'hasnt been 2 hours since last greeted for this user
            Exit Sub
        End If
    End If
    'user has been previously greeted, check times
    frmMain.lstGreetedUsers(Index).AddItem APointer & theName & ACross & GTC
    'add to recently greeted list
    
    'set
    '7200000
    If JoinGreet Then
      GreetMessage = aProfile(Index).GreetJoinMessage
    Else
      GreetMessage = aProfile(Index).GreetLeaveMessage
    End If
    'sets greet message to be sent
    If InStrB(GreetMessage, "%n") Then GreetMessage = Replace$(GreetMessage, "%n", theName)
    If InStrB(GreetMessage, "%p") Then GreetMessage = Replace$(GreetMessage, "%p", thePing)
    If InStrB(GreetMessage, "%c") Then GreetMessage = Replace$(GreetMessage, "%c", aProfile(Index).Channel)
    If InStrB(GreetMessage, "%u") Then GreetMessage = Replace$(GreetMessage, "%u", Random_Userlist_Name(Index))
    'replace variables
    'decided to do lowercase only being thats how its displayed
    Dim GreetSplit() As String, arrIndex As Integer, EchoCommand As Boolean
    If InStrB(GreetMessage, "; ") Then GreetMessage = Replace$(GreetMessage, "; ", ";")
    'parse multiple commands with GreetMessage
    GreetSplit = Split(GreetMessage, ";")
    For arrIndex = 0 To UBound(GreetSplit)
        If Right$(LCase$(GreetSplit(arrIndex)), 5) = "@echo" Then
            EchoCommand = True
            GreetSplit(arrIndex) = Left$(GreetSplit(arrIndex), Len(GreetSplit(arrIndex)) - 5)
        Else
            EchoCommand = False
        End If
        'determine if it needs to be echod
        If Not Remote_Commands(aProfile(Index).RealName, GreetSplit(arrIndex), aProfile(Index).RealPing, Index, EchoCommand, False, True) Then
            QueueString GreetSplit(arrIndex) & Auto000, Index, False
        End If
    Next arrIndex
    'if not a remote command then queue
'    QueueString GreetMessage, Index, False

End Sub

Public Sub HandleMemoMail(ByVal theName As String, ByVal theMessage As String, ByRef Index As Integer)
Dim isMail As Boolean, theTick As Currency

    Select Case Left$(LCase$(theMessage), 6)
        Case "!mail "
            isMail = True 'is mail
        'sent mail
        Case "!memo "
            If Not botElements.Memos Then Exit Sub
            'memos are not enabled
            isMail = False 'is a memo
        'sent a memo
        Case Else: Exit Sub 'is nothing, exit
    End Select
    'check type or exit
    
    Dim theAccess As Long
    theAccess = get_Access(theName, Index)
    'gets users access
    
    theTick = GTC
    '
    botElements.MailMemoTick = botElements.MailMemoTick - (theAccess * 40)
    'determines how much time to reduce the wait until anotehr can mail by.
    'if the user has more than 500 access all wait time is removed
    
    If theTick - botElements.MailMemoTick < 20000 Then Exit Sub
    'hasnt been 20 seconds since last mail or memo received for the entire bot
    
    
    theMessage = Mid$(theMessage, 7)
  
    If isMail Then
        If Not botElements.MailWithoutAccess And theAccess = 0 Then Exit Sub
        'if is mail, and require access is enabled, and user has none then exit
        Dim theReceiver As String, StringLoc As Integer
        StringLoc = InStr(theMessage, ASpace)
        If StringLoc = 0 Then Exit Sub
        'no space to seperate the name and the message
        theReceiver = Left$(theMessage, StringLoc - 1)
        theMessage = Mid$(theMessage, StringLoc + 1)
        'sets sender and message
        If LCase$(TruncNumber(AttachRealmDouble(AttachRealmSingle(theName, Index), theReceiver, Index))) = LCase$(aProfile(Index).RealNameConverted) Then GoTo HandleMemoMail_SubmitMemo
        'if sending to the bot owner, it forces it as a memo
        submitMail theName, LCase$(theReceiver), theMessage, Index, False
    'submit mail
    Else
HandleMemoMail_SubmitMemo:
        If LenB(theMessage) Then submitMemo theName, theMessage, Index
        'print, mark as new memo, and queue reply
    'submit memo
    End If
  
    botElements.MailMemoTick = theTick
    'for memos use 20 second default tick
  
  
End Sub


Private Sub submitMemo(ByRef MemoSender As String, ByRef MemoMessage As String, ByRef Index As Integer)

    MemoSender = FirstNameConversion(MemoSender, Index)
    '
    Dim FileNumber As Integer
    FileNumber = FreeFile
    '
    Open App.Path & "\Text\Memos.txt" For Append As #FileNumber
    Print #FileNumber, "From: " & MemoSender & vbCrLf & "Message: " & MemoMessage & vbCrLf
    Close #FileNumber
    'prints to file w/ full realm name
    botElements.MemoRecieved = True
    'enables
    QueueString AWhisper & MemoSender & GetString(119), Index 'Your memo has been recieved.
    '
    
End Sub
'stores memos and queues the reply

Public Sub submitMail(ByRef theSender As String, ByRef theReceiver As String, ByRef theMessage As String, ByRef Index As Integer, ByRef SystemMail As Boolean)

    Dim whispName As String
    whispName = theSender
    'the first name conversion routine removes the # so it can reply with a confirmation that the user received their mail.
    If Not SystemMail Then
    'if not bot sending the mail
        theSender = FirstNameConversion(theSender, Index)
        theReceiver = LCase$(AttachRealmDouble(theSender, theReceiver, Index))
    Else
        theSender = "{" & aProfile(Index).RealName & "}"
        'if the bot is sending the mail
    End If
    'sets sender and receiver as converted
    Dim FileNumber As Integer
    FileNumber = FreeFile
    '
    Open App.Path & "\Text\Mail.txt" For Append As #FileNumber
    Print #FileNumber, theReceiver & "#" & ChangeRealmIndexToName(Index) & ACross & Date$ & "/" & Time$ & ACross & theSender & ACross & theMessage
    Close #FileNumber
    'print to file
    If InStrB(botElements.MailUsers(aProfile(Index).BNETRealm), APointer & theReceiver & ACross) = 0 Then botElements.MailUsers(aProfile(Index).BNETRealm) = botElements.MailUsers(aProfile(Index).BNETRealm) & APointer & theReceiver & ACross
    'if not in the mailing list already, then add
    If Not SystemMail Then
    'if not sending mail from within bot
        QueueString AWhisper & whispName & GetString(130), Index 'Your mail has been set for outbound
    Else
    'if is local command
        QueueString GetString(130), Index, True 'Your mail has been set for outbound
    End If
    
End Sub
'stores mail and queues the reply

Public Function GetClient(ByVal theMessage As String, ByVal theFlags As Long, ByVal theName As String, ByRef Index As Integer) As String
Dim theClient As String, clientIcon As Byte, listPosition As Byte
Dim myName As Boolean

    theClient = Left$(theMessage, 4)
    If theName = aProfile(Index).RealName Then myName = True 'used to not show squelch icon on self
    'bw sc d2 ect
    If Right$(theMessage, 4) = "GPCW" Then
        
        clientIcon = 28
        'ogl of bnet!
    
    Else
    'if not
    
        Select Case theClient
            Case Str_PXES:     clientIcon = 1 'bw client
            Case Str_RATS:     clientIcon = 2 'sc client
            Case Str_PX2D:     clientIcon = 3 'd2 expansion
            Case Str_VD2D:     clientIcon = 4 'd2 reg
            Case Str_NB2W:     clientIcon = 5 'w2
            Case Str_PX3W:     clientIcon = 6 'w3 xpan
            Case Str_3RAW:     clientIcon = 7 'w3 original
            Case Str_TAHC:     clientIcon = 8 'chat
            Case Str_RHSS:     clientIcon = 9 'sc shareware
            Case Str_LTRD:     clientIcon = 10 'diablo retail
            Case Str_RHSD:     clientIcon = 1 'diablo shareware
            Case Str_RTSJ:     clientIcon = 12 'jap sc
            Case Else:       clientIcon = 13 'couldnt get valid client
        End Select
        'set client based off message string
        
        If botElements.SelfIcons Then
            Select Case clientIcon
                Case 1: If aProfile(Index).GameClient = Str_PXES Then clientIcon = 33
                Case 2: If aProfile(Index).GameClient = Str_RATS Then clientIcon = 32
                Case 3: If aProfile(Index).GameClient = Str_PX2D Then clientIcon = 37
                Case 4: If aProfile(Index).GameClient = Str_VD2D Then clientIcon = 34
                Case 5: If aProfile(Index).GameClient = Str_NB2W Then clientIcon = 35
                Case 6: If aProfile(Index).GameClient = Str_PX3W Then clientIcon = 38
                Case 7: If aProfile(Index).GameClient = Str_3RAW Then clientIcon = 36
            End Select
        End If
        'check self icons
        
    End If
    'gets client icon
  
  'operator   2
    'rep        1
    'ignore     32
    'plug       16
    If (theFlags And 2) = 2 Then 'op
        If (theFlags And 32) = 32 And Not myName Then
            clientIcon = 16
        'ignored operator
        Else
            clientIcon = 15
        'not iggy oper
        End If
    'if operator
    ElseIf (theFlags And 64) = 64 Or (theFlags And 1) = 1 Or (theFlags And 4) = 4 Or (theFlags And 8) = 8 Then
        If (theFlags And 32) = 32 Then
            clientIcon = 17
        'iggy rep
        Else
            clientIcon = 14
        'normal rep
        End If
    'special guest, rep, speaker, bnet admin
    ElseIf (theFlags And 32) = 32 And Not myName Then
        clientIcon = 18
        'squelched with no special flags
    'squelched
    End If
    Dim theClan As String
    'tag/channel
  
    theClan = ASpace
    'default
    If theClient = Str_3RAW Or theClient = Str_PX3W Then
    'if w3 client check for clan tag
        If theName = aProfile(Index).RealName Then
            theClan = aProfile(Index).RealClan
        'set selfs clan
        Else
        'not profiles name
            Dim clanSplit() As String
            'split array
            clanSplit = Split(theMessage, ASpace)
            If UBound(clanSplit) > 2 Then
                theClan = StrReverse$(clanSplit(UBound(clanSplit)))
                'sets to proper length
                aProfile(Index).ClanTag(0) = theName
                aProfile(Index).ClanTag(1) = theClan
                'stores this so it can be used within a flag update
            End If
        End If
    Else
        If LenB(theMessage) = 0 Then
            If aProfile(Index).ClanTag(0) = theName Then
                theClan = aProfile(Index).ClanTag(1)
                'set clan tag
                Erase aProfile(Index).ClanTag
            End If
        End If
        'recover the clan tag
    End If
    'get clan tag
    Dim ObtainedOps As Byte
    '
    If clientIcon > 13 And clientIcon < 18 Then
        'set to be added to the top, 1 is top 0 is default
        If InStrB(aProfile(Index).OperatorList, ACross & theName & ASnake) = 0 Then
            listPosition = 0 '
            ObtainedOps = 1
            'set position
            aProfile(Index).OperatorList = aProfile(Index).OperatorList & ACross & theName & ASnake
            'add to list
            If aProfile(Index).FilterRandomJoins > 0 Then aProfile(Index).FilterRandomJoins = aProfile(Index).FilterRandomJoins - 1
            'reduce random joins by one
            If theName = aProfile(Index).RealName Then
                aProfile(Index).Operator = True
                'set self as operator
                If GTC - aProfile(Index).UptimeTick < 10000 Then
                    aProfile(Index).QueueRaiseFactor = 50
                    aProfile(Index).QueueWaitTick = aProfile(Index).QueueWaitTick + 3000
                End If
                'if became operator within 7 seconds of being loaded then raise queue 3 seconds and raise factor.
                'this is so the bot doesnt start banning upon connecting ipbanning itself.
                'CompileString = APointer & theName & ACross & theSplit(2) & ACross & GetPing(thePing, theFlags) & ACross & thePing & ACross & theSplit(1) & ACross & theSplit(4) & ACross & joinTick & ACross & filterDetection
        'username and client-icon# and ping-icon# and actual-ping and w3clan_or_? and client-string and TickCount and Filter Mark and Name-Converted
                Dim arrIndex As Integer, userSplit() As String
                For arrIndex = 0 To (frmMain.lstUserStorage(Index).ListCount - 1)
                'if became ops run through channel list to see if anyone has to be banned
                    userSplit = Split(frmMain.lstUserStorage(Index).List(arrIndex), ACross)
                    'If EntryType = 0 Or LCase$(theSplit(1)) = aProfile(Index).ChannelClanTag Then
                    If LCase$(userSplit(4)) <> aProfile(Index).ChannelClanTag Then
                    'if not a clan member
                        Call PerformOperatorChecks(Mid$(userSplit(0), 2), 0, userSplit(5), clientIcon, Index, True, -1)
                    End If
                    'only check if the user is not of the w3 clan
                    If clientIcon = 15 Or clientIcon = 16 Then
                    'if iggy icon.
                    'only here if obtained ops.
                    End If
                Next
            End If
        Else
            ObtainedOps = 0
            listPosition = frmMain.lstUserStorage(Index).ListCount
        End If
        'find position
        If theName = aProfile(Index).RealName And ObtainedOps Then
            Dim tabNumber As Integer
            tabNumber = get_TabOnProfile(Index)
            '
            If tabNumber <> -1 Then
                If frmMain.tabTable.Tabs.Item(tabNumber).Image = 4 Then
                    frmMain.tabTable.Tabs(tabNumber).Image = 6
                'if current icon is no new chat, update to op no new chat
                Else
                    frmMain.tabTable.Tabs(tabNumber).Image = 7
                'update to op icon with new chat
                End If
            End If
            'if tab is loaded
        End If
    'if rep or op
    Else
        listPosition = frmMain.lstUserStorage(Index).ListCount
    End If
    'determines where to add in list (top or default)
    'if they are a new op or existing
    'and if to change tab icon
    GetClient = listPosition & ACross & theClan & ACross & clientIcon & ACross & ObtainedOps & ACross & theClient
    'split(0) T/F[for top] ,  split(1) ?/clanTag  ,  split(2)  iconNumber  ,  split(3)  obtained-ops T/F  ,  split(4)  client-string
    
End Function
'gets client icon #


Private Function GetPing(ByVal thePing As Long, ByVal theFlags As Long) As Integer

    Select Case thePing
        Case -1
            If ((theFlags And 16) = 16) Then
                GetPing = 26 'purple plug
            Else
                GetPing = 27 'purple -1
            End If
            'plug check
        '-1 check
        Case 0
            If ((theFlags And 16) = 16) Then
                GetPing = 47 'gray plug
            Else
                GetPing = 19 '1 gray bar
            End If
            'plug check
        '0 check
        Case Else
        'ping bars
            If ((theFlags And 16) = 16) Then
                GetPing = 40 'normal plugged
            Else
            'if no tplugged
                Select Case thePing
                    Case 1 To 199
                        GetPing = 20
                    '1g
                    Case 200 To 299
                        GetPing = 21
                    '2g
                    Case 300 To 399
                        GetPing = 22
                    '3y
                    Case 400 To 499
                        GetPing = 23
                    '4y
                    Case 500 To 599
                        GetPing = 24
                    '5r
                    Case Else
                        GetPing = 25
                    '6r
                End Select
                'get ping type icon
            End If
        'ping bars or plug regular
    End Select

End Function
'gets ping icon #

Public Sub updateUserlist()

On Error GoTo Err

    If botElements.LVState = 0 Then
      
        KillTimer frmMain.hwnd, 0
        'kill the timer
                       
        Dim arrIndex As Integer, dataSplit() As String, overWrite As Boolean
        Dim theName As String, clientIcon As Byte, pingIcon As Byte, thePing As Long, timeInChannel As Long
        '
        Do Until LenB(frmMain.lstUserStorage(botElements.ActiveChatIndex).List(arrIndex)) = 0
                        
                dataSplit() = Split(frmMain.lstUserStorage(botElements.ActiveChatIndex).List(arrIndex), ACross)
                If UBound(dataSplit) > 5 Then
                'username client-icon# ping-icon# actual-ping w3clan_or_? client-string in-chan-tickcount
                'splits info - username client-icon# ping-icon# actual-ping time-in-chan-tick
                    dataSplit(0) = Mid$(dataSplit(0), 2)
                    'removes the  indicator
                    theName = vbNullString
                    clientIcon = 0
                    pingIcon = 0
                    thePing = 0
                    'reset vars
                    If Not botElements.UserlistRepaint And frmMain.lvUserlist.ListItems.Count > arrIndex Then
                        theName = frmMain.lvUserlist.ListItems(arrIndex + 1).Text
                        clientIcon = frmMain.lvUserlist.ListItems(arrIndex + 1).SmallIcon
                        pingIcon = frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ListSubItems.Item(1).ReportIcon
                        thePing = frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ListSubItems.Item(1).ToolTipText
                        'gets current info from the lv
                    End If
                    'stores the old values from lv index vs this array index
                    If dataSplit(0) = theName And dataSplit(1) = clientIcon And dataSplit(2) = pingIcon And dataSplit(3) = thePing Then
                    'if all things match up skip this entry
                        GoTo UpdateUserlist_NextArrIndex
                    Else
                    'if the UI details dont match up with the stored then re-write entry
                        If frmMain.lvUserlist.ListItems.Count > arrIndex Then
                        'modify existing entry here
                            frmMain.lvUserlist.ListItems.Item(arrIndex + 1).Text = dataSplit(0)
                            'change user name text
                            frmMain.lvUserlist.ListItems.Item(arrIndex + 1).SmallIcon = Val#(dataSplit(1))
                            'change icon
                            frmMain.lvUserlist.ListItems(arrIndex + 1).ListSubItems.Item(1).ReportIcon = Val#(dataSplit(2))
                            'change ping icon
                            frmMain.lvUserlist.ListItems(arrIndex + 1).ListSubItems.Item(1).ToolTipText = dataSplit(3)
                            'change ping tooltip
                            frmMain.lvUserlist.ListItems(arrIndex + 1).ListSubItems.Item(2).Text = dataSplit(4)
                            'change clan tag
                            frmMain.lvUserlist.ListItems(arrIndex + 1).ListSubItems.Item(2).ToolTipText = dataSplit(4)
                            'change ping tooltip part 2
                        Else
                        'no entry to modify so add as new
                            frmMain.lvUserlist.ListItems.Add (arrIndex + 1), , dataSplit(0), , Val#(dataSplit(1))
                            'adds username + client icon
                            frmMain.lvUserlist.ListItems(arrIndex + 1).ListSubItems.Add , , , Val#(dataSplit(2)), dataSplit(3)
                            'adds ping icon + ping hover value
                            frmMain.lvUserlist.ListItems(arrIndex + 1).ListSubItems.Add , , dataSplit(4), , dataSplit(4)
                            'adds clan tag if it exist
                        End If
                        'updates the icon toolip and what not
                        frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ForeColor = vbWhite
                        'sets to white, normal, incase ppl use ghey themes
                        If InStrB(aProfile(botElements.ActiveChatIndex).IdleUsersGrayed, APointer & dataSplit(0) & ACross) Then frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ForeColor = &H808080
                        'grays idle users
                        If InStrB(aProfile(botElements.ActiveChatIndex).OperatorList, ACross & dataSplit(0) & ASnake) Then frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ForeColor = &HC0FFFF
                        'colors operators
                        If InStrB(dataSplit(0), "#Blizzard") Then frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ForeColor = vbCyan
                        'colors reps
                        If dataSplit(0) = aProfile(botElements.ActiveChatIndex).RealName Then frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ForeColor = &HFFC0C0
                        'colors self name
                        If InList(APointer & LCase$(RemoveFirstStar(FirstNameConversion(dataSplit(0), botElements.ActiveChatIndex))) & ACross, frmMain.lstFilteredNames, False, False) <> -1 Then frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ForeColor = &H80FF&
                        'colors filtered names
                        If Not aProfile(botElements.ActiveChatIndex).Connected Then frmMain.lvUserlist.ListItems.Item(arrIndex + 1).ForeColor = vbRed
                        'color if not connected
                        'ordered in color priority bottom to top
                    End If
                    
                'if proper ubound
                End If
                
UpdateUserlist_NextArrIndex:
    
    
          arrIndex = arrIndex + 1
          'bump next name
          
        Loop
      
        Do Until frmMain.lvUserlist.ListItems.Count <= arrIndex
            frmMain.lvUserlist.ListItems.Remove (frmMain.lvUserlist.ListItems.Count)
        Loop
        'removes usersnames no longer in channel
        'AddChat 0, 1, vbYellow, isSelected(frmMain.lvUserlist)
        If Not botElements.UserlistPainted Then
            Dim myLoc As Integer
            myLoc = lv_FindItem(aProfile(botElements.ActiveChatIndex).RealName)
            'try to find bots name in userlist
            If myLoc = -1 Then If frmMain.lvUserlist.ListItems.Count <> 0 Then myLoc = 1
            'if some reason the bot owner couldnt be found in channel set to first index
            If myLoc > 0 Then
                frmMain.lvUserlist.ListItems(myLoc).Selected = True
                'select
                Modify_UserlistSelection True
            End If
        End If
        'always have a name hightlighted to prevent flashing
        
        Modify_UserlistSelection False
        'check if the selection needs to be moved
        Set_ChannelCaption False
        'update channel count
        botElements.UserlistRepaint = False
        'unset
  
    End If
    'if updating then
  
Err:
End Sub
'when called on 250ms timer, checks if active profile needs a userlist update

Public Sub Set_ChannelCaption(ByRef ChannelUpdate As Boolean)
    
    If Not aProfile(botElements.ActiveChatIndex).Connected Then
        If botElements.ActiveChatIndex = 0 Then
        'if the status window
            frmMain.lblActiveChannelName = "Hidden Tabs"
            frmMain.lblActiveChannelCount = "#"
        Else
            frmMain.lblActiveChannelName = "-Not Connected-"
            frmMain.lblActiveChannelCount.Caption = "0"
        End If
    Else
        If ChannelUpdate Then frmMain.lblActiveChannelName.Caption = aProfile(botElements.ActiveChatIndex).Channel
        'update channel name
        frmMain.lblActiveChannelCount.Caption = frmMain.lvUserlist.ListItems.Count
        'update channel count
        'if connected
    End If
    'just for show

End Sub
'sets the channel the user is in and the the amount of users in the channel

Public Sub Set_IdleTick(ByVal theName As String, ByRef Index As Integer, ByRef RemoveEntry As Boolean, ByRef theTick As Currency)
Dim listLoc As Integer

    theName = APointer & theName & ACross
    listLoc = InList(theName, frmMain.lstIdleTicks(Index), False, False)
    'gets position in idle list
    If listLoc = -1 Then
        If InStrB(aProfile(Index).IdleUsersGrayed, theName) Then aProfile(Index).IdleUsersGrayed = Replace$(aProfile(Index).IdleUsersGrayed, theName, vbNullString)
        'if in idle list then remove, since we are re-adding the user is no longer idle
        If Not RemoveEntry Then frmMain.lstIdleTicks(Index).AddItem theName & theTick
        'if not set to remove the add
    'if not in the list then add
    Else
        frmMain.lstIdleTicks(Index).RemoveItem listLoc
        'remove
        If Not RemoveEntry Then frmMain.lstIdleTicks(Index).AddItem theName & theTick
        'remove and then re-add if specified to
        If InStrB(aProfile(Index).IdleUsersGrayed, theName) Then
            aProfile(Index).IdleUsersGrayed = Replace$(aProfile(Index).IdleUsersGrayed, theName, vbNullString)
            'remove user from idle status
            If Not RemoveEntry Then Set_UserlistUpdate Index, True, True
            'update userlist with the now idle
        End If
    'if in list set with new tickcount and or remove
    End If

End Sub
'sets the users new idleTalk tick and unGrays if grayed
  


Public Sub Set_UserlistUpdate(ByRef Index As Integer, ByRef updateNow As Boolean, ByRef Repaint As Boolean)
Static LastTick As Currency, TimerActive As Boolean

    If botElements.LVState <> 0 Then Exit Sub
    'exit if not showing channel users
    If Index <> botElements.ActiveChatIndex Then Exit Sub
    'exit if not current index
    If Repaint Then botElements.UserlistRepaint = True
    'if true then modify all entries regardless of if they match or not
    Dim RefreshDelay As Currency
    If aProfile(Index).FilterTriggered Then
        RefreshDelay = 1500
    Else
        RefreshDelay = 500
    End If
    'use a slightly longer update delay if filters are triggered
    Dim theTick As Currency
    theTick = GTC
    '
    If updateNow Then
        TimerActive = False
        'unset
        KillTimer frmMain.hwnd, 0
        'remove timer
        updateUserlist
        '
        LastTick = theTick
        'last time updated
    Else
        If theTick - LastTick > RefreshDelay Then
            'if its been over 500ms since last write, allow update
            TimerActive = False
            'unset
            updateUserlist
            LastTick = theTick
            'last time updated
        ElseIf Not TimerActive Then
            TimerActive = True
            'set
            KillTimer frmMain.hwnd, 0
            SetTimer frmMain.hwnd, 0, (RefreshDelay - (theTick - LastTick)), AddressOf updateUserlist
            'set timer to update
        End If
    End If
    
End Sub
